
import { _decorator, Component, Node, game } from 'cc';
import { gg } from '../../scripts/framework/gg';
import AssetLoader from '../../scripts/framework/lib/asset/AssetLoader';
import { BundleConfigs } from './configs/BundleConfigs';
import { PanelConfigs } from './configs/PanelConfigs';
const { ccclass, property } = _decorator;

/**
 * Predefined variables
 * Name = MainSceneCtrl
 * DateTime = Thu May 05 2022 14:07:07 GMT+0800 (中国标准时间)
 * Author = liyahu1234
 * FileBasename = MainSceneCtrl.ts
 * FileBasenameNoExtension = MainSceneCtrl
 * URL = db://assets/mainbundle/scripts/MainSceneCtrl.ts
 * ManualUrl = https://docs.cocos.com/creator/3.4/manual/zh/
 *
 */

@ccclass('MainSceneCtrl')
export class MainSceneCtrl extends Component {
    @property(Node)
    rootLayerNode: Node = null;

    onLoad() {
        game.frameRate = 61;
        // 初始化日志管理器
        gg.logger.init({
            enableLog: true,
        });

        // 初始化面板路由器
        gg.panelRouter.init(this.node, true);
    }

    async start() {
        // 加载 Bundle
        await AssetLoader.loadBundle(BundleConfigs.LobbyBundle);
        await AssetLoader.loadBundle(BundleConfigs.CommonBundle)

        // 加载启动页
        await gg.panelRouter.loadAsync(PanelConfigs.bootPanel);

        // 打开启动页
        gg.panelRouter.show({
            panel: PanelConfigs.bootPanel,
        });
    }

}