import { Asset, AssetManager, assetManager, BufferAsset } from "cc";
import LoadMgr from "../load/LoadMgr";
import LoadResConst from "../../mainbundle/scripts/configs/LoadResConst";
import { ILoadResInfo } from "../load/interfaces/ILoadResInfo";
import { gg } from "../framework/gg";

export default class ZipFileMgr {
    private static TAG: string = "ZipFileMgr";
    private static _inst: ZipFileMgr;

    public static get Inst(): ZipFileMgr {
        if (ZipFileMgr._inst == null) {
            ZipFileMgr._inst = new ZipFileMgr();
        }
        return ZipFileMgr._inst;
    }

    /**
     * 同步加载资源
     * @param resInfo 
     */
    public async getJsonList(resInfo: ILoadResInfo) {
        let assets: BufferAsset = await LoadMgr.Inst.getAssetAsync(resInfo);
        let jsondata: any = this.loadZip(assets);
        return jsondata;
    }

    private loadZip(assets: BufferAsset) {
        if (!assets) {
            console.error(ZipFileMgr.TAG, "::loadZip-> assets is null");
            return;
        } else {
            let zip = new JSZip(assets.buffer());
            let reg: RegExp = /.*?/;
            let jlist: JSZipObject[] = zip.file(reg);
            let curLoad = 0;
            let allNum = jlist.length;
            let jsData: any = {};
            for (let i of jlist) {
                gg.logger.log(ZipFileMgr.TAG, "::loadZip-> parse: " + i.name);
                let c = i.name.split('.')[0];
                let d = JSON.parse(i.asText());
                d = this._filterNullItem(d);
                // if (c) c.InitDataWith(d);
                // else {
                //     gg.logger.warn(ConfigTableMgr.TAG, "::loadZip->没有该配置对应解析类 ！ " + i.name);
                // }
                jsData[c] = d;
                curLoad = curLoad + 1;
            }
            if (allNum == curLoad) {
                gg.logger.warn(ZipFileMgr.TAG, "log4dev ---本地配置zip读取完成---");
                return jsData;
            }

        }
    }
    private _filterNullItem(data: Array<any>) {
        for (let i = 0; i < data.length; ++i) {
            if (Object.keys(data[i]).length == 0) {
                data.splice(i, 1);
                i -= 1;
            }
        }
        return data;
    }

}