System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Component, EventHandler, _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _crd, ccclass, property, ScrollViewPlusItemComponent;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      EventHandler = _cc.EventHandler;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "7f5b39BSitAI5UInHCyhUmy", "ScrollViewPlusItemComponent", undefined);

      ({
        ccclass,
        property
      } = _decorator);
      /**
       * 配合「ScrollViewPlus」组件使用的ScrollViewItem组件
       *
       * @author caizhitao
       * @created 2020-12-27 22:08:00
       * @description
       *
       * 用法：
       * 
       *      1. 将本组件挂载在Item节点上
       *      2. 在属性面板上指定事件数组回调，即可监听 Item 「进入」和「离开」ScrollView可视区域的事件
       */

      _export("default", ScrollViewPlusItemComponent = (_dec = property({
        type: [EventHandler],
        tooltip: "进入ScrollView时回调"
      }), _dec2 = property({
        type: [EventHandler],
        tooltip: "离开ScrollView时回调"
      }), _dec3 = property({
        type: [EventHandler],
        tooltip: "进入ScrollView之后，位置发生改变时回调"
      }), ccclass(_class = (_class2 = class ScrollViewPlusItemComponent extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "onEnterScorllViewEvents", _descriptor, this);

          _initializerDefineProperty(this, "onExitScorllViewEvents", _descriptor2, this);

          _initializerDefineProperty(this, "onPositionChangeEvents", _descriptor3, this);

          this.isShowing = false;
        }

        onDisable() {
          this.isShowing = false;
        }
        /**
         * Item 进入 ScrollView 的时候回调
         */


        publishOnEnterScrollView() {
          if (this.onEnterScorllViewEvents) {
            this.onEnterScorllViewEvents.forEach(event => {
              event.emit([]);
            });
          }
        }
        /**
         * Item 离开 ScrollView 的时候回调
         */


        publishOnExitScrollView() {
          if (this.onExitScorllViewEvents) {
            this.onExitScorllViewEvents.forEach(event => {
              event.emit([]);
            });
          }
        }
        /**
         * Item 进入 ScrollView 后，位置发生移动时回调，离开ScrollView后不会回调
         *
         * @param xOffsetPercent 相对于 ScrollView 可视区域中心点，X的偏移量百分比，取值范围：[0, 1]。其中，0：为在可视区域最左边，1：为可视区域最右边
         * @param yOffsetPercent 相对于 ScrollView 可视区域中心点，Y的偏移量百分比，取值范围：[0, 1]。其中，0：为在可视区域最下边，1：为可视区域最上边
         */


        publishOnPositionChange(xOffsetPercent, yOffsetPercent) {
          if (this.onPositionChangeEvents) {
            this.onPositionChangeEvents.forEach(event => {
              event.emit([xOffsetPercent, yOffsetPercent]);
            });
          }
        }

      }, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "onEnterScorllViewEvents", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "onExitScorllViewEvents", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "onPositionChangeEvents", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=6dea6d3e26dc26ca879b368228d1919a97476196.js.map