System.register(["__unresolved_0", "cc", "__unresolved_1", "__unresolved_2", "__unresolved_3"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, Node, assetManager, Prefab, Widget, instantiate, gg, PanelStateEnum, PanelComponent, PanelRouter, _crd;

  function _reportPossibleCrUseOfgg(extras) {
    _reporterNs.report("gg", "../../gg", _context.meta, extras);
  }

  function _reportPossibleCrUseOfPanelConfig(extras) {
    _reporterNs.report("PanelConfig", "./PanelConfig", _context.meta, extras);
  }

  function _reportPossibleCrUseOfPanelStateEnum(extras) {
    _reporterNs.report("PanelStateEnum", "./PanelStateEnum", _context.meta, extras);
  }

  function _reportPossibleCrUseOfPanelComponent(extras) {
    _reporterNs.report("PanelComponent", "./PanelComponent", _context.meta, extras);
  }

  _export("default", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      Node = _cc.Node;
      assetManager = _cc.assetManager;
      Prefab = _cc.Prefab;
      Widget = _cc.Widget;
      instantiate = _cc.instantiate;
    }, function (_unresolved_2) {
      gg = _unresolved_2.gg;
    }, function (_unresolved_3) {
      PanelStateEnum = _unresolved_3.PanelStateEnum;
    }, function (_unresolved_4) {
      PanelComponent = _unresolved_4.PanelComponent;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "f41c4fpeFdNIb0cA/X508sZ", "PanelRouter", undefined);

      /**
       * 面板路由器
       *
       * 面板结构如下：
       *
       * - 图层1
       *   - 面板1
       *   - 面板2
       * - 图层2
       *   - 面板3
       *   - 面板4
       * - ...
       *
       * 根据面板所以依附的图层节点的zIndex 来决定面板的显示前后顺序（zIndex大的图层会挡住zIndex小的图层）
       *
       * 本工具提供以下方法：
       *
       * * init
       * * preload
       * * load
       * * loadAsync
       * * show
       * * showAsync
       * * hide
       * * hideAsync
       * * destroy
       * * getPanelState
       *
       * @author caizhitao
       * @created 2020-11-28 09:51:33
       */
      _export("default", PanelRouter = class PanelRouter {
        constructor() {
          this._enabledLog = true;
          this._rootNode = null;
          this._layerNodeMap = new Map();
          this._panelCacheMap = new Map();
        }

        /**
         * 初始化面板路由器
         *
         * @param rootNode 图层根节点（此节点建议最好是扩充全屏的）
         * @param enableDebugLog 是否允许打印面板路由器操作日志
         */
        init(rootNode, enableDebugLog) {
          this._enabledLog = enableDebugLog;
          this._rootNode = rootNode;
        }
        /**
         * 预加载面板资源（只下载到本地，不加载解析到内存）
         */


        preload(panelConfig) {
          let preloadBundlePrefab = bundle => {
            let prefabPath = panelConfig.prefabPath.substring(panelConfig.prefabPath.indexOf("/") + 1);
            bundle.preload(prefabPath);
          };

          let bundleName = panelConfig.prefabPath.substring(0, panelConfig.prefabPath.indexOf("/"));
          let bundle = assetManager.getBundle(bundleName);

          if (bundle == null) {
            assetManager.loadBundle(bundleName, (error, bundle) => {
              preloadBundlePrefab(bundle);
            });
          } else {
            preloadBundlePrefab(bundle);
          }
        }
        /**
         * （Promise）加载面板资源（加载到内存）
         */


        loadAsync(panelConfig) {
          return new Promise((resolve, reject) => {
            this.load(panelConfig, error => {
              error ? reject(error) : resolve();
            });
          });
        }
        /**
         * 加载面板资源（加载到内存）
         */


        load(panelConfig, onCompleted) {
          let prefabPath = panelConfig.prefabPath;

          let panelCache = this._panelCacheMap.get(prefabPath);

          if (panelCache) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试加载面板", "面板已加载成功");
            onCompleted(null);
            return;
          }

          this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
            error: Error()
          }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试加载面板", "面板还不存在，将开始加载面板"); // 初始化面板状态并记录下来

          panelCache = {
            node: null,
            prefab: null,
            state: (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
              error: Error()
            }), PanelStateEnum) : PanelStateEnum).Loading
          };

          this._panelCacheMap.set(prefabPath, panelCache); // 开始加载面板


          panelCache.state = (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Loading;

          this._loadBundlePrefab(panelConfig, null, (error, prefab) => {
            // 加载完毕后，需要在此获取面板状态
            // 因为加载是一个过程，这个过程中，面板可能被销毁了等等之类，因此加载完毕后，重新获取面板状态
            panelCache = this._panelCacheMap.get(prefabPath);

            if (error) {
              // 处理面板实际加载失败的逻辑
              this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                error: Error()
              }), gg) : gg).logger.error(PanelRouter.Tag, prefabPath, "尝试加载面板", "加载面板失败", error);

              if (!panelCache) {
                this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                  error: Error()
                }), gg) : gg).logger.warn(PanelRouter.Tag, prefabPath, "尝试加载面板", "当前已经找不到面板记录，可能面板加载过程中触发销毁，导致加载结束后找不到对应面板记录");
              } else {
                if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                  error: Error()
                }), PanelStateEnum) : PanelStateEnum).LoadFailure || panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                  error: Error()
                }), PanelStateEnum) : PanelStateEnum).LoadSuccess || panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                  error: Error()
                }), PanelStateEnum) : PanelStateEnum).Showing || panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                  error: Error()
                }), PanelStateEnum) : PanelStateEnum).Showed || panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                  error: Error()
                }), PanelStateEnum) : PanelStateEnum).Hiding || panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                  error: Error()
                }), PanelStateEnum) : PanelStateEnum).Hided) {
                  this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                    error: Error()
                  }), gg) : gg).logger.error(PanelRouter.Tag, prefabPath, "尝试加载面板", "面板状态异常，原则上不会出现这个状态", panelCache.state);
                } else {
                  // 更新面板状态
                  panelCache.node = null;
                  panelCache.prefab = null;
                  panelCache.state = (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                    error: Error()
                  }), PanelStateEnum) : PanelStateEnum).LoadFailure;
                }
              }
            } else {
              // 处理面板实际加载成功的逻辑
              this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                error: Error()
              }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试加载面板", "加载面板成功");

              if (!panelCache) {
                this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                  error: Error()
                }), gg) : gg).logger.warn(PanelRouter.Tag, prefabPath, "尝试加载面板", "当前已经找不到面板记录，可能面板加载过程中触发销毁，导致加载结束后找不到对应面板记录"); // 销毁 prefab

                prefab.decRef();
              } else {
                if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                  error: Error()
                }), PanelStateEnum) : PanelStateEnum).LoadFailure || panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                  error: Error()
                }), PanelStateEnum) : PanelStateEnum).LoadSuccess || panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                  error: Error()
                }), PanelStateEnum) : PanelStateEnum).Showing || panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                  error: Error()
                }), PanelStateEnum) : PanelStateEnum).Showed || panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                  error: Error()
                }), PanelStateEnum) : PanelStateEnum).Hiding || panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                  error: Error()
                }), PanelStateEnum) : PanelStateEnum).Hided) {
                  this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                    error: Error()
                  }), gg) : gg).logger.error(PanelRouter.Tag, prefabPath, "尝试加载面板", "面板状态异常，原则上不会出现这个状态", panelCache.state);
                } else {
                  // 更新面板状态
                  panelCache.node = null;
                  panelCache.prefab = prefab;
                  panelCache.state = (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                    error: Error()
                  }), PanelStateEnum) : PanelStateEnum).LoadSuccess; // Prefab 引用 + 1

                  panelCache.prefab.addRef();
                }
              }
            }

            onCompleted(error);
          });
        }

        _loadBundlePrefab(panelConfig, onProgress, onCompleted) {
          let loadBundlePrefab = bundle => {
            let prefabPath = panelConfig.prefabPath.substring(panelConfig.prefabPath.indexOf("/") + 1);
            bundle.load(prefabPath, Prefab, onProgress, (error, prefab) => {
              onCompleted(error, prefab);
            });
          };

          let bundleName = panelConfig.prefabPath.substring(0, panelConfig.prefabPath.indexOf("/"));
          let bundle = assetManager.getBundle(bundleName);

          if (bundle == null) {
            assetManager.loadBundle(bundleName, (error, bundle) => {
              loadBundlePrefab(bundle);
            });
          } else {
            loadBundlePrefab(bundle);
          }
        }
        /**
         * （Promise）展示面板
         *
         * @param option 展示面板的参数
         */


        showAsync(option) {
          return new Promise((resolve, reject) => {
            this.show({
              panel: option.panel,
              data: option.data,
              onShowed: error => {
                error ? reject(error) : resolve();
              }
            });
          });
        }
        /**
         * 展示面板
         *
         * @param option 展示面板的参数
         */


        show(option) {
          let prefabPath = option.panel.prefabPath;

          let panelCache = this._panelCacheMap.get(prefabPath);

          if (!panelCache) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.error(PanelRouter.Tag, prefabPath, "尝试展示面板", "面板还没有加载，不能展示");
            option.onShowed && option.onShowed(new Error("show error"));
            return;
          }

          if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Loading) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.error(PanelRouter.Tag, prefabPath, "尝试展示面板", "面板在加载中，不能展示");
            option.onShowed && option.onShowed(new Error("show error"));
            return;
          }

          if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).LoadFailure) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.error(PanelRouter.Tag, prefabPath, "尝试展示面板", "面板加载失败，不能展示");
            option.onShowed && option.onShowed(new Error("show error"));
            return;
          }

          if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).LoadSuccess) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试展示面板", "面板已加载成功，将尝试展示面板");

            this._showPanel(option, panelCache);

            return;
          }

          if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Showing) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试展示面板", "面板正在展示中");

            this._showPanel(option, panelCache);

            return;
          }

          if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Showed) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试展示面板", "面板已展示");

            this._showPanel(option, panelCache);

            return;
          }

          if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Hiding) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试展示面板", "面板在隐藏中，将停止隐藏动画，并立即开始展示");

            this._showPanel(option, panelCache);

            return;
          }

          if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Hided) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试展示面板", "面板已隐藏，将重新展示");

            this._showPanel(option, panelCache);

            return;
          }
        }

        _showPanel(option, panelCache) {
          if (panelCache.node == null) {
            // 获取面板层级节点
            let panelLayerNode = this._layerNodeMap.get(option.panel.layerZIndex);

            if (panelLayerNode == null) {
              panelLayerNode = new Node();
              panelLayerNode.setSiblingIndex(option.panel.layerZIndex); // 为图层添加 Widget 组件，扩充至全屏尺寸

              let widget = panelLayerNode.addComponent(Widget);
              widget.top = 0;
              widget.bottom = 0;
              widget.left = 0;
              widget.right = 0;
              widget.isAlignTop = true;
              widget.isAlignBottom = true;
              widget.isAlignLeft = true;
              widget.isAlignRight = true;
              widget.alignMode = Widget.AlignMode.ON_WINDOW_RESIZE; // 将图层节点添加到根节点中

              this._rootNode.addChild(panelLayerNode); // 缓存层级节点


              this._layerNodeMap.set(option.panel.layerZIndex, panelLayerNode);
            } // 将面板加入到层级节点中


            let panelNode = instantiate(panelCache.prefab);
            panelNode.setPosition(0, 0);
            panelNode.setParent(panelLayerNode);
            panelCache.node = panelNode;
          }

          panelCache.state = (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Showing;
          panelCache.node.active = true;
          panelCache.node.getComponent(_crd && PanelComponent === void 0 ? (_reportPossibleCrUseOfPanelComponent({
            error: Error()
          }), PanelComponent) : PanelComponent).show({
            data: option.data,
            onShowed: () => {
              this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                error: Error()
              }), gg) : gg).logger.log(PanelRouter.Tag, option.panel.prefabPath, "尝试展示面板", "面板已经展示完成");
              panelCache.state = (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                error: Error()
              }), PanelStateEnum) : PanelStateEnum).Showed;
              option.onShowed && option.onShowed();
            }
          });
        }
        /**
         * （Promise）隐藏面板
         *
         * @param option 隐藏面板的参数
         */


        hideAsync(option) {
          return new Promise((resolve, reject) => {
            this.hide({
              panel: option.panel,
              data: option.data,
              onHided: error => {
                error ? reject(error) : resolve();
              }
            });
          });
        }
        /**
         * 隐藏面板
         *
         * @param option 隐藏面板的参数
         */


        hide(option) {
          let prefabPath = option.panel.prefabPath;

          let panelCache = this._panelCacheMap.get(prefabPath);

          if (!panelCache) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.error(PanelRouter.Tag, prefabPath, "尝试隐藏面板", "面板还没有加载，不能隐藏");
            option.onHided && option.onHided(new Error("hide error"));
            return;
          }

          if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Loading) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.error(PanelRouter.Tag, prefabPath, "尝试隐藏面板", "面板在加载中，不能隐藏");
            option.onHided && option.onHided(new Error("hide error"));
            return;
          }

          if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).LoadFailure) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.error(PanelRouter.Tag, prefabPath, "尝试隐藏面板", "面板加载失败，不能隐藏");
            option.onHided && option.onHided(new Error("hide error"));
            return;
          }

          if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).LoadSuccess) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.error(PanelRouter.Tag, prefabPath, "尝试隐藏面板", "面板已加载成功，但未展示，不能隐藏");
            option.onHided && option.onHided(new Error("hide error"));
            return;
          }

          if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Showing) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试隐藏面板", "面板在展示中（可能正在执行展示动画），将停止展示并立即隐藏");

            this._hidePanel(option, panelCache);

            return;
          }

          if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Showed) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试隐藏面板", "面板已展示，将立即隐藏");

            this._hidePanel(option, panelCache);

            return;
          }

          if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Hiding) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试隐藏面板", "面板正在隐藏中");

            this._hidePanel(option, panelCache);

            return;
          }

          if (panelCache.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Hided) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试隐藏面板", "面板已隐藏");

            this._hidePanel(option, panelCache);

            return;
          }
        }

        _hidePanel(option, panelCache) {
          panelCache.state = (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Hiding;
          panelCache.node.getComponent(_crd && PanelComponent === void 0 ? (_reportPossibleCrUseOfPanelComponent({
            error: Error()
          }), PanelComponent) : PanelComponent).hide({
            data: option.data,
            onHided: () => {
              this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                error: Error()
              }), gg) : gg).logger.log(PanelRouter.Tag, option.panel.prefabPath, "尝试隐藏面板", "面板隐藏成功");
              panelCache.state = (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
                error: Error()
              }), PanelStateEnum) : PanelStateEnum).Hided;
              panelCache.node.active = false;
              option.onHided && option.onHided();
            }
          });
        }
        /**
         * 销毁面板
         *
         * @param option 销毁参数
         */


        destroy(option) {
          let prefabPath = option.panel.prefabPath;

          let panel = this._panelCacheMap.get(prefabPath);

          if (!panel) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.error(PanelRouter.Tag, prefabPath, "尝试销毁面板", "当前面板还不存在（建议检查为什么此时触发销毁方法）");
            return;
          }

          if (panel.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Loading) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.warn(PanelRouter.Tag, prefabPath, "尝试销毁面板", "面板在加载中时，将销毁面板资源（建议检查为什么此时触发了销毁方法）");

            this._destroyPanel(panel, prefabPath);

            return;
          }

          if (panel.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).LoadFailure) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试销毁面板", "面板加载已经失败，将销毁面板资源");

            this._destroyPanel(panel, prefabPath);

            return;
          }

          if (panel.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).LoadSuccess) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试销毁面板", "面板加载已经成功（但无后续操作），将销毁面板资源");

            this._destroyPanel(panel, prefabPath);

            return;
          }

          if (panel.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Showing) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.warn(PanelRouter.Tag, prefabPath, "尝试销毁面板", "面板在展示中（可能正在执行展示动画），将销毁面板资源（建议检查为什么此时触发了销毁方法）");

            this._destroyPanel(panel, prefabPath);

            return;
          }

          if (panel.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Showed) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.warn(PanelRouter.Tag, prefabPath, "尝试销毁面板", "面板已展示，将销毁面板资源（建议检查为什么此时触发了销毁方法）");

            this._destroyPanel(panel, prefabPath);

            return;
          }

          if (panel.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Hiding) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.warn(PanelRouter.Tag, prefabPath, "尝试销毁面板", "面板在隐藏中（可能正在执行隐藏动画），将销毁面板资源（建议检查为什么此时触发了销毁方法）");

            this._destroyPanel(panel, prefabPath);

            return;
          }

          if (panel.state === (_crd && PanelStateEnum === void 0 ? (_reportPossibleCrUseOfPanelStateEnum({
            error: Error()
          }), PanelStateEnum) : PanelStateEnum).Hided) {
            this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试销毁面板", "面板已隐藏，将销毁面板资源");

            this._destroyPanel(panel, prefabPath);

            return;
          }
        }

        _destroyPanel(panelCache, prefabPath) {
          if (panelCache.node) {
            panelCache.node.destroy();
            panelCache.node = null;
          }

          if (panelCache.prefab) {
            panelCache.prefab.decRef();
            panelCache.prefab = null;
          }

          this._panelCacheMap.delete(prefabPath);

          this._enabledLog && (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
            error: Error()
          }), gg) : gg).logger.log(PanelRouter.Tag, prefabPath, "尝试销毁面板", "面板销毁成功");
        }
        /**
         * 获取面板当前状态
         *
         * @returns 如果还没有创建或者已经销毁了，那么返回null，否则返回对应的状态
         */


        getPanelState(panelConfig) {
          let panel = this._panelCacheMap.get(panelConfig.prefabPath);

          if (!panel) {
            return null;
          }

          return panel.state;
        }

      });

      PanelRouter.Tag = "PanelRouter";

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=e595957b12545b8cca9529ee9c7de8ccb61ba06d.js.map