System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Component, Enum, Sprite, Widget, UITransform, v3, _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _crd, ccclass, property, SpriteScaleType, SpriteAlignType, SpriteScaleAdapterComponent;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  _export({
    SpriteScaleType: void 0,
    SpriteAlignType: void 0
  });

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Enum = _cc.Enum;
      Sprite = _cc.Sprite;
      Widget = _cc.Widget;
      UITransform = _cc.UITransform;
      v3 = _cc.v3;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "19cd1EtCxROy74vuajdNybo", "SpriteScaleAdapterComponent", undefined);

      ({
        ccclass,
        property
      } = _decorator);
      /**
       * 缩放方式
       */

      (function (SpriteScaleType) {
        SpriteScaleType[SpriteScaleType["FILL"] = 0] = "FILL";
        SpriteScaleType[SpriteScaleType["SUIT"] = 1] = "SUIT";
      })(SpriteScaleType || _export("SpriteScaleType", SpriteScaleType = {}));

      (function (SpriteAlignType) {
        SpriteAlignType[SpriteAlignType["LEFT"] = 0] = "LEFT";
        SpriteAlignType[SpriteAlignType["TOP"] = 1] = "TOP";
        SpriteAlignType[SpriteAlignType["RIGHT"] = 2] = "RIGHT";
        SpriteAlignType[SpriteAlignType["BOTTOM"] = 3] = "BOTTOM";
        SpriteAlignType[SpriteAlignType["CENTER"] = 4] = "CENTER";
      })(SpriteAlignType || _export("SpriteAlignType", SpriteAlignType = {}));

      _export("default", SpriteScaleAdapterComponent = (
      /**
       * Sprite 适配组件
       *
       * @author caizhitao
       * @created 2020-12-27 21:22:43
       */
      _dec = property({
        type: Enum(SpriteScaleType),
        tooltip: "缩放类型:\n-FILL: 缩放到填满父节点（图像可能会被裁剪，但父节点有空白）\n-SUIT: 缩放到刚好在父节点内部最大化显示（图像会完整显示，但父节点上下或者左右可能会留空）"
      }), _dec2 = property({
        type: Enum(SpriteAlignType),
        tooltip: "对齐方式类型:\n如：\n-LEFT: 缩放后靠左对齐"
      }), ccclass(_class = (_class2 = class SpriteScaleAdapterComponent extends Component {
        constructor() {
          super(...arguments);

          _initializerDefineProperty(this, "scaleType", _descriptor, this);

          _initializerDefineProperty(this, "alignType", _descriptor2, this);

          this._sprite = null;
        }

        onLoad() {
          this._sprite = this.node.getComponent(Sprite);
        }

        start() {
          this.updateSprite(this.scaleType, this.alignType);
        }

        onEnable() {
          var onResize = this._onResize.bind(this);

          window.addEventListener("resize", onResize);
          window.addEventListener("orientationchange", onResize);
        }

        onDisable() {
          var onResize = this._onResize.bind(this);

          window.removeEventListener("resize", onResize);
          window.removeEventListener("orientationchange", onResize);
        }

        _onResize() {
          this.updateSprite(this.scaleType, this.alignType);
        }

        updateSprite(scaleType, alignType) {
          if (!this._sprite || !this._sprite.enabled || !this._sprite.spriteFrame) {
            return;
          }

          var widget = this.node.parent.getComponent(Widget);

          if (widget) {
            widget.updateAlignment();
          }

          this.node.getComponent(UITransform).width = this._sprite.spriteFrame.getRect().width;
          this.node.getComponent(UITransform).height = this._sprite.spriteFrame.getRect().height;

          if (this.node.getComponent(UITransform).width / this.node.getComponent(UITransform).height > this.node.parent.getComponent(UITransform).width / this.node.parent.getComponent(UITransform).height) {
            // 设计分辨率宽高比大于显示分辨率
            if (scaleType == SpriteScaleType.SUIT) {
              var scale = this.node.parent.getComponent(UITransform).width / this.node.getComponent(UITransform).width;
              this.node.setScale(scale, scale);
            } else if (scaleType == SpriteScaleType.FILL) {
              var _scale = this.node.parent.getComponent(UITransform).height / this.node.getComponent(UITransform).height;

              this.node.setScale(_scale, _scale);
            }
          } else {
            // 设计分辨率宽高比小于显示分辨率
            if (scaleType == SpriteScaleType.SUIT) {
              var _scale2 = this.node.parent.getComponent(UITransform).height / this.node.getComponent(UITransform).height;

              this.node.setScale(_scale2, _scale2);
            } else if (scaleType == SpriteScaleType.FILL) {
              var _scale3 = this.node.parent.getComponent(UITransform).width / this.node.getComponent(UITransform).width;

              this.node.setScale(_scale3, _scale3);
            }
          }

          switch (alignType) {
            case SpriteAlignType.CENTER:
              this.node.setPosition(v3());
              break;

            case SpriteAlignType.LEFT:
              this.node.setPosition(v3(-0.5 * (this.node.parent.getComponent(UITransform).width - this.node.getComponent(UITransform).width * this.node.scale.x), 0));
              break;

            case SpriteAlignType.RIGHT:
              this.node.setPosition(v3(0.5 * (this.node.parent.getComponent(UITransform).width - this.node.getComponent(UITransform).width * this.node.scale.x), 0));
              break;

            case SpriteAlignType.TOP:
              this.node.setPosition(v3(0, 0.5 * (this.node.parent.getComponent(UITransform).height - this.node.getComponent(UITransform).height * this.node.scale.x)));
              break;

            case SpriteAlignType.BOTTOM:
              this.node.setPosition(v3(0, -0.5 * (this.node.parent.getComponent(UITransform).height - this.node.getComponent(UITransform).height * this.node.scale.x)));
              break;
          }
        }

      }, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "scaleType", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return SpriteScaleType.SUIT;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "alignType", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return SpriteAlignType.CENTER;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=24073c9bff95a499bb1d8405b3eb192d5cc305be.js.map