System.register(["__unresolved_0", "cc"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, NativeLogger, _crd;

  function _reportPossibleCrUseOfLoggerInterface(extras) {
    _reporterNs.report("LoggerInterface", "./LoggerInterface", _context.meta, extras);
  }

  function _reportPossibleCrUseOfLoggerOption(extras) {
    _reporterNs.report("LoggerOption", "./LoggerInterface", _context.meta, extras);
  }

  _export("default", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "af841vr8f9P8LYkxi3eze6B", "NativeLogger", undefined);

      /**
       * 原生日志输出管理器
       *
       * 会将 [object object] 转换为 object Json 化后的结果
       *
       * @author caizhitao
       * @created 2020-11-26 22:52:46
       */
      _export("default", NativeLogger = class NativeLogger {
        constructor() {
          this._option = null;
        }

        init(option) {
          this._option = option;
        }

        log() {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          this._option && this._option.enableLog && console.info(this._format(args));
        }

        debug() {
          for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }

          this._option && this._option.enableLog && console.debug(this._format(args));
        }

        info() {
          for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            args[_key3] = arguments[_key3];
          }

          this._option && this._option.enableLog && console.info(this._format(args));
        }

        error() {
          for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
            args[_key4] = arguments[_key4];
          }

          this._option && this._option.enableLog && console.error(this._format(args));
        }

        warn() {
          for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
            args[_key5] = arguments[_key5];
          }

          this._option && this._option.enableLog && console.warn(this._format(args));
        }
        /**
         * 原生平台上不能直接打印object和array，因此这里将object和array转换为字符串进行输出，方便在 Android Logcat 中直接看 log 结果
         */


        _format() {
          var msg = "";

          for (var _len6 = arguments.length, args = new Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
            args[_key6] = arguments[_key6];
          }

          args.forEach((value, index, array) => {
            if (value == null) {
              msg += "null";
            } else {
              var valType = typeof value;

              if (valType === "string" || valType === "number") {
                msg += value;
              } else {
                msg += JSON.stringify(value);
              }
            }

            if (index + 1 < array.length) {
              msg += ",";
            }
          });
          return msg;
        }

      });

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=5b3513c1209b1345f95009bf0482ee0bf05b6157.js.map